package swingtables.logic;

import swingtables.logic.entities.DbGenre;
import swingtables.logic.entities.DbGenreJpaController;
import swingtables.logic.entities.DbMovie;
import swingtables.logic.entities.DbMovieJpaController;

public class DatabaseSetup {

    public static void main(String[] args) {
        DbGenreJpaController genreJpaController = new DbGenreJpaController(MoviesDatasource.getInstance().getEmf());
        DbGenre genreComedy = new DbGenre();
        DbGenre genreDrama = new DbGenre();
        DbGenre genreBiography = new DbGenre();
        DbGenre genreAction = new DbGenre();
        DbGenre genreAdventure = new DbGenre();
        
        genreComedy.setGenreName("Comedy");
        genreJpaController.create(genreComedy);
        
        genreDrama.setGenreName("Drama");
        genreJpaController.create(genreDrama);
        
        genreBiography.setGenreName("Biography");
        genreJpaController.create(genreBiography);

        genreAction.setGenreName("Action");
        genreJpaController.create(genreAction);
        
        genreAdventure.setGenreName("Adventure");
        genreJpaController.create(genreAdventure);
        
        DbMovieJpaController movieJpaController = new DbMovieJpaController(MoviesDatasource.getInstance().getEmf());
        DbMovie dbMovie;
        
        dbMovie = new DbMovie();
        dbMovie.setColor(true);
        dbMovie.setGenre(genreAction);
        dbMovie.setTitle("The Dark Knight");
        dbMovie.setYearOfProduction(2008);
        movieJpaController.create(dbMovie);
        
        dbMovie = new DbMovie();
        dbMovie.setColor(true);
        dbMovie.setGenre(genreAdventure);
        dbMovie.setTitle("Il buono, il brutto, il cattivo");
        dbMovie.setYearOfProduction(1966);
        movieJpaController.create(dbMovie);
        
        dbMovie = new DbMovie();
        dbMovie.setColor(true);
        dbMovie.setGenre(genreComedy);
        dbMovie.setTitle("Intouchables");
        dbMovie.setYearOfProduction(2011);
        movieJpaController.create(dbMovie);
        
        dbMovie = new DbMovie();
        dbMovie.setColor(true);
        dbMovie.setGenre(genreBiography);
        dbMovie.setTitle("Rush");
        dbMovie.setYearOfProduction(2013);
        movieJpaController.create(dbMovie);
    }
}
