/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package swingtables.logic.entities;

import java.io.Serializable;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Query;
import javax.persistence.EntityNotFoundException;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;
import swingtables.logic.entities.exceptions.NonexistentEntityException;

/**
 *
 * @author trust56
 */
public class DbGenreJpaController implements Serializable {

    public DbGenreJpaController(EntityManagerFactory emf) {
        this.emf = emf;
    }
    private EntityManagerFactory emf = null;

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    public void create(DbGenre dbGenre) {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            em.persist(dbGenre);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(DbGenre dbGenre) throws NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            dbGenre = em.merge(dbGenre);
            em.getTransaction().commit();
        } catch (Exception ex) {
            String msg = ex.getLocalizedMessage();
            if (msg == null || msg.length() == 0) {
                Integer id = dbGenre.getId();
                if (findDbGenre(id) == null) {
                    throw new NonexistentEntityException("The dbGenre with id " + id + " no longer exists.");
                }
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void destroy(Integer id) throws NonexistentEntityException {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            DbGenre dbGenre;
            try {
                dbGenre = em.getReference(DbGenre.class, id);
                dbGenre.getId();
            } catch (EntityNotFoundException enfe) {
                throw new NonexistentEntityException("The dbGenre with id " + id + " no longer exists.", enfe);
            }
            em.remove(dbGenre);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<DbGenre> findDbGenreEntities() {
        return findDbGenreEntities(true, -1, -1);
    }

    public List<DbGenre> findDbGenreEntities(int maxResults, int firstResult) {
        return findDbGenreEntities(false, maxResults, firstResult);
    }

    private List<DbGenre> findDbGenreEntities(boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
            cq.select(cq.from(DbGenre.class));
            Query q = em.createQuery(cq);
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
        } finally {
            em.close();
        }
    }

    public DbGenre findDbGenre(Integer id) {
        EntityManager em = getEntityManager();
        try {
            return em.find(DbGenre.class, id);
        } finally {
            em.close();
        }
    }

    public int getDbGenreCount() {
        EntityManager em = getEntityManager();
        try {
            CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
            Root<DbGenre> rt = cq.from(DbGenre.class);
            cq.select(em.getCriteriaBuilder().count(rt));
            Query q = em.createQuery(cq);
            return ((Long) q.getSingleResult()).intValue();
        } finally {
            em.close();
        }
    }
    
}
