package swingtables.logic.entities;

import java.io.Serializable;
import java.util.Calendar;
import java.util.List;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import swingtables.logic.EntityWithID;
import swingtables.logic.MoviesDatasource;

@Entity
public class DbMovie implements Serializable, EntityWithID {

   
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Integer id;

    @Override
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DbMovie)) {
            return false;
        }
        DbMovie other = (DbMovie) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }
    private String title;

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }
    private Integer yearOfProduction;

    public Integer getYearOfProduction() {
        return yearOfProduction;
    }

    public void setYearOfProduction(Integer yearOfProduction) {
        this.yearOfProduction = yearOfProduction;
    }
    private Boolean color;

    public Boolean isColor() {
        return color;
    }

    public void setColor(Boolean color) {
        this.color = color;
    }
    
    @OneToOne
    private DbGenre genre;

    public DbGenre getGenre() {
        return genre;
    }

    public void setGenre(DbGenre genre) {
        this.genre = genre;
    }

    @Override
    public String toString() {
        return getTitle();
    }

    public void setDefaultValues() {
        title = "<new movie>";
        yearOfProduction = Calendar.getInstance().get(Calendar.YEAR);
        color = true;
        List<DbGenre> genres = MoviesDatasource.getInstance().getGenres();
        genre = genres.isEmpty() ? null : genres.get(0);
    }
}
