/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package swingtables.logic.entities;

import java.io.Serializable;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Query;
import javax.persistence.EntityNotFoundException;
import javax.persistence.TypedQuery;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;
import swingtables.logic.entities.exceptions.NonexistentEntityException;

/**
 *
 * @author trust56
 */
public class DbMovieJpaController implements Serializable {

    public DbMovieJpaController(EntityManagerFactory emf) {
        this.emf = emf;
    }
    private EntityManagerFactory emf = null;

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    public void create(DbMovie dbMovie) {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            em.persist(dbMovie);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(DbMovie dbMovie) throws NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            dbMovie = em.merge(dbMovie);
            em.getTransaction().commit();
        } catch (Exception ex) {
            String msg = ex.getLocalizedMessage();
            if (msg == null || msg.length() == 0) {
                Integer id = dbMovie.getId();
                if (findDbMovie(id) == null) {
                    throw new NonexistentEntityException("The dbMovie with id " + id + " no longer exists.");
                }
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void destroy(Integer id) throws NonexistentEntityException {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            DbMovie dbMovie;
            try {
                dbMovie = em.getReference(DbMovie.class, id);
                dbMovie.getId();
            } catch (EntityNotFoundException enfe) {
                throw new NonexistentEntityException("The dbMovie with id " + id + " no longer exists.", enfe);
            }
            em.remove(dbMovie);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<DbMovie> findDbMovieEntities() {
        return findDbMovieEntities(true, -1, -1);
    }

    public List<DbMovie> findDbMovieEntities(int maxResults, int firstResult) {
        return findDbMovieEntities(false, maxResults, firstResult);
    }

    private List<DbMovie> findDbMovieEntities(boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            CriteriaQuery<DbMovie> cq = em.getCriteriaBuilder().createQuery(DbMovie.class);
            cq.select(cq.from(DbMovie.class));
            TypedQuery<DbMovie> q = em.createQuery(cq);
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            final List<DbMovie> resultList = q.getResultList();
            return resultList;
        } finally {
            em.close();
        }
    }

    public DbMovie findDbMovie(Integer id) {
        EntityManager em = getEntityManager();
        try {
            return em.find(DbMovie.class, id);
        } finally {
            em.close();
        }
    }

    public int getDbMovieCount() {
        EntityManager em = getEntityManager();
        try {
            CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
            Root<DbMovie> rt = cq.from(DbMovie.class);
            cq.select(em.getCriteriaBuilder().count(rt));
            Query q = em.createQuery(cq);
            return ((Long) q.getSingleResult()).intValue();
        } finally {
            em.close();
        }
    }
    
}
